#ifndef GenericSingleton_H
#define GenericSingleton_H

template <typename T>
class GenericSingleton
{
public:
   static T &getInstance();

protected:
   GenericSingleton();

private:
   static T m_instance;
};

template <typename T>
GenericSingleton<T>::GenericSingleton()
{}

template <typename T>
T & GenericSingleton<T>::getInstance()
{
    return m_instance;
}

template <typename T>
T GenericSingleton<T>::m_instance;

#endif /* GenericSingleton_H */


